"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.suite = void 0;

var React = _interopRequireWildcard(require("react"));

var _index = require("../styles/index.js");

var _index2 = require("./index.js");

var _examplesList = _interopRequireDefault(require("./examples-list.js"));

var _examples$ACCORDION_E;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var suite = 'Component Test Suite';
exports.suite = suite;
var Centered = (0, _index.styled)('div', {
  position: 'relative',
  display: 'flex',
  flexDirection: 'row',
  justifyContent: 'center',
  alignItems: 'start',
  height: '90vh',
  lineHeight: 1.5,
  width: '500px',
  margin: '0 auto'
});
Centered.displayName = "Centered";
var panelOverrides = {
  Header: {
    props: {
      'data-title': 'data-title'
    },
    style: {
      borderBottom: '1px solid #916cb2',
      color: '#4f1e7b'
    }
  },
  Content: {
    style: function style(_ref) {
      var $expanded = _ref.$expanded;
      return {
        backgroundColor: '#efe6f7',
        borderBottom: $expanded ? '1px solid #916cb2' : 'none'
      };
    }
  },
  ToggleIcon: {
    props: {
      title: 'Toggle expandable block',
      'data-label': 'toggle'
    },
    style: {
      backgroundColor: '#916cb2',
      color: '#fff',
      borderRadius: '50%',
      paddingTop: '5px',
      paddingBottom: '5px',
      paddingLeft: '5px',
      paddingRight: '5px'
    }
  }
};
var content = 'Praesent condimentum ante ac ipsum aliquam, ac scelerisque velit sagittis. Ut sit amet libero scelerisque, accumsan ante vitae, hendrerit tellus. Nullam metus est, vehicula a aliquet id, lobortis in mauris.';

var _default = (_examples$ACCORDION_E = {}, _defineProperty(_examples$ACCORDION_E, _examplesList.default.ACCORDION_EXAMPLE, function Story1() {
  return React.createElement(Centered, null, React.createElement(_index2.Accordion, null, React.createElement(_index2.Panel, {
    title: "Accordion panel 1"
  }, content), React.createElement(_index2.Panel, {
    title: "Accordion panel 2"
  }, content), React.createElement(_index2.Panel, {
    title: "Accordion panel 3"
  }, content)));
}), _defineProperty(_examples$ACCORDION_E, _examplesList.default.STYLE_PROPS_OVERRIDES, function Story2() {
  return React.createElement(Centered, null, React.createElement(_index2.Accordion, {
    initialState: {
      expanded: ['panel-1']
    }
  }, React.createElement(_index2.Panel, {
    key: "panel-1",
    title: "Accordion panel 1",
    overrides: panelOverrides
  }, content), React.createElement(_index2.Panel, {
    title: "Accordion panel 2",
    overrides: panelOverrides
  }, content), React.createElement(_index2.Panel, {
    disabled: true,
    title: "Accordion panel 3",
    overrides: panelOverrides
  }, content)));
}), _defineProperty(_examples$ACCORDION_E, _examplesList.default.SINGLE_STATEFUL_PANEL, function Story3() {
  return React.createElement(Centered, null, React.createElement(_index2.StatefulPanel, {
    title: "Expandable panel"
  }, content));
}), _examples$ACCORDION_E);

exports.default = _default;