"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _constants = require("./constants.js");

var _index = require("./utils/index.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultStateReducer = function defaultStateReducer(type, nextState) {
  return nextState;
};

var NavigationContainer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(NavigationContainer, _React$Component);

  function NavigationContainer() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, NavigationContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(NavigationContainer)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      highlightedDate: _this.props.highlightedDate || _this.getSingleDate(_this.props.selected) || new Date(),
      isActive: true,
      lastHighlightedDate: _this.props.highlightedDate || _this.getSingleDate(_this.props.selected) || new Date()
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setActiveState", function (isActive) {
      if (typeof document !== 'undefined') {
        var method = isActive ? 'addEventListener' : 'removeEventListener'; // $FlowFixMe

        document[method]('keydown', _this.onKeyDown);

        _this.internalSetState(null, {
          isActive: isActive
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onSelect", function (data) {
      if (_this.state.isActive) {
        _this.props.onSelect(data);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onKeyDown", function (event) {
      switch (event.key) {
        case 'ArrowUp':
        case 'ArrowDown':
        case 'ArrowLeft':
        case 'ArrowRight':
          _this.handleArrowKey(event.key);

          event.preventDefault();
          event.stopPropagation();
          break;
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDayMouseOver", function (data) {
      var date = data.date;
      var stateReducer = _this.props.stateReducer;

      _this.setState(function (prevState) {
        return stateReducer(_constants.STATE_CHANGE_TYPE.mouseOver, {
          highlightedDate: date
        }, prevState);
      });

      _this.props.onDayMouseOver(data);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDayMouseLeave", function (data) {
      var date = data.date;
      var _this$props = _this.props,
          stateReducer = _this$props.stateReducer,
          value = _this$props.selected;

      var selected = _this.getSingleDate(value);

      var inSameMonth = (0, _index.isSameMonth)(selected, date);
      var inSameYear = (0, _index.isSameYear)(selected, date);
      var nextState;

      if (selected && inSameMonth && inSameYear) {
        nextState = {
          highlightedDate: selected
        };
      } else {
        nextState = {
          lastHighlightedDate: date,
          highlightedDate: null
        };
      }

      _this.setState(function (prevState) {
        return stateReducer(_constants.STATE_CHANGE_TYPE.mouseLeave, nextState, prevState);
      });

      _this.props.onDayMouseLeave(data);
    });

    return _this;
  }

  _createClass(NavigationContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (typeof document !== 'undefined') {
        if (this.state.isActive) {
          document.addEventListener('keydown', this.onKeyDown);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        if (this.state.isActive) {
          document.removeEventListener('keydown', this.onKeyDown);
        }
      }
    }
  }, {
    key: "getSingleDate",
    value: function getSingleDate(value) {
      if (Array.isArray(value)) {
        return value[0] || null;
      } else {
        return value;
      }
    }
  }, {
    key: "handleArrowKey",
    value: function handleArrowKey(key) {
      var _this$state = this.state,
          oldDate = _this$state.highlightedDate,
          lastHighlightedDate = _this$state.lastHighlightedDate;
      var highlightedDate = oldDate ? oldDate : null;
      var stateChangeType = null;

      switch (key) {
        case 'ArrowLeft':
          // adding `new Date()` as the last option to satisfy Fow
          highlightedDate = (0, _index.subDays)(highlightedDate ? highlightedDate : lastHighlightedDate || new Date(), 1);
          stateChangeType = _constants.STATE_CHANGE_TYPE.moveLeft;
          break;

        case 'ArrowRight':
          highlightedDate = (0, _index.addDays)( // adding `new Date()` as the last option to satisfy Fow
          highlightedDate ? highlightedDate : lastHighlightedDate || new Date(), 1);
          stateChangeType = _constants.STATE_CHANGE_TYPE.moveRight;
          break;

        case 'ArrowUp':
          highlightedDate = (0, _index.subWeeks)( // adding `new Date()` as the last option to satisfy Fow
          highlightedDate ? highlightedDate : lastHighlightedDate || new Date(), 1);
          stateChangeType = _constants.STATE_CHANGE_TYPE.moveUp;
          break;

        case 'ArrowDown':
          highlightedDate = (0, _index.addWeeks)( // adding `new Date()` as the last option to satisfy Fow
          highlightedDate ? highlightedDate : lastHighlightedDate || new Date(), 1);
          stateChangeType = _constants.STATE_CHANGE_TYPE.moveDown;
          break;
      }

      this.internalSetState(stateChangeType, {
        highlightedDate: highlightedDate
      });
    }
  }, {
    key: "internalSetState",
    value: function internalSetState(type, changes) {
      var stateReducer = this.props.stateReducer;
      this.setState(function (prevState) {
        return stateReducer(type, changes, prevState);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          stateReducer = _this$props2.stateReducer,
          rest = _objectWithoutProperties(_this$props2, ["children", "stateReducer"]); // $FlowFixMe


      return this.props.children(_objectSpread({}, rest, {
        highlightedDate: this.state.highlightedDate,
        onDayMouseOver: this.onDayMouseOver,
        onDayMouseLeave: this.onDayMouseLeave,
        onSelect: this.onSelect,
        setActiveState: this.setActiveState
      }));
    }
  }]);

  return NavigationContainer;
}(React.Component);

_defineProperty(NavigationContainer, "defaultProps", {
  stateReducer: defaultStateReducer,
  onDayMouseOver: function onDayMouseOver() {},
  onDayMouseLeave: function onDayMouseLeave() {},
  onSelect: function onSelect() {}
});

var _default = NavigationContainer;
exports.default = _default;