"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('StatefulList', function () {
  test('basic render', function () {
    function CustomRoot() {
      return _react.default.createElement("span", null);
    }

    var props = {
      overrides: {
        Root: CustomRoot
      },
      initialState: {
        items: ['Item 1', 'Item 2']
      },
      onChange: jest.fn(),
      stateReducer: jest.fn()
    };
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StatefulList, props));
    expect(component.props()).toMatchObject(props);
  });
});