"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Component styled components', function () {
  test('StyledRoot - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledRoot, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledRoot has correct styles');
  });
  test('StyledList - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledList, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledList has correct styles');
  });
  test('StyledList - dragging is active', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledList, {
      $isDragged: true
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledList has correct styles when dragging is active');
  });
  test('StyledItem - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledItem, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledItem has correct styles');
  });
  test('StyledItem - dragged', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledItem, {
      $isDragged: true
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledItem has correct styles when being dragged');
  });
  test('StyledItem - selected', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledItem, {
      $isSelected: true
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledItem has correct styles when being selected');
  });
  test('StyledDragHandle - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledDragHandle, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledDragHandle has correct styles');
  });
  test('StyledCloseHandle - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledCloseHandle, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledCloseHandle has correct styles');
  });
  test('StyledLabel - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledLabel, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledLabel has correct styles');
  });
});