function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    getPuppeteerUrl = _require.getPuppeteerUrl,
    analyzeAccessibility = _require.analyzeAccessibility;

var suite = 'Card Test Suite';
describe(suite, function () {
  var scenariosList = Object.keys(scenarios);

  var _loop = function _loop(i) {
    it("passes basic a11y tests for ".concat(scenariosList[i]),
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var page, accessibilityReport;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return browser.newPage();

            case 2:
              page = _context.sent;
              _context.next = 5;
              return page.goto(getPuppeteerUrl({
                suite: suite,
                test: scenarios[scenariosList[i]]
              }));

            case 5:
              _context.next = 7;
              return analyzeAccessibility(page, {
                rules: [{
                  id: 'image-alt',
                  enabled: false
                }]
              });

            case 7:
              accessibilityReport = _context.sent;
              expect(accessibilityReport).toHaveNoAccessibilityIssues();

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    })));
  };

  for (var i = 0; i < scenariosList.length; i++) {
    _loop(i);
  }
});