"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Header Navigation styled components', function () {
  describe('StyledRoot', function () {
    test('Root', function () {
      var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledRoot, null, _react.default.createElement("div", null)));
      expect(component.instance().getStyles()).toMatchSnapshot('StyledRoot has correct styles');
    });
  });
  describe('NavigationList', function () {
    test('NavigationList', function () {
      var component = (0, _enzyme.mount)(_react.default.createElement(_index.StyledNavigationList, null, _react.default.createElement("div", null)));
      Object.values(_index.ALIGN).forEach(function (align) {
        component.setProps({
          align: align
        });
        expect(component.instance().getStyles()).toMatchSnapshot( // $FlowFixMe
        "NavigationList has correct styles when set to align ".concat(align));
      });
    });
  });
  describe('NavigationItem', function () {
    test('NavigationItem', function () {
      var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledNavigationItem, null, _react.default.createElement("div", null)));
      expect(component.instance().getStyles()).toMatchSnapshot('NavigationItem has correct styles');
    });
  });
});