"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */

/* global document */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    getPuppeteerUrl = _require.getPuppeteerUrl,
    analyzeAccessibility = _require.analyzeAccessibility;

var suite = 'Modal Test Suite';
var selectors = {
  closeButton: 'button[aria-label="Close"]',
  openModal: '.open-modal-button',
  dialog: '[role="dialog"]'
};
describe(suite, function () {
  it('handles focus changes properly',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var dialogIsFocused, accessibilityReport, openIsFocused;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.SIMPLE_EXAMPLE
            }));

          case 2:
            _context.next = 4;
            return page.waitFor(selectors.closeButton);

          case 4:
            _context.next = 6;
            return page.click(selectors.closeButton);

          case 6:
            _context.next = 8;
            return page.waitFor(selectors.closeButton, {
              hidden: true
            });

          case 8:
            _context.next = 10;
            return page.click(selectors.openModal);

          case 10:
            _context.next = 12;
            return page.waitFor(selectors.dialog);

          case 12:
            _context.next = 14;
            return page.$eval(selectors.dialog, function (dialog) {
              return dialog === document.activeElement;
            });

          case 14:
            dialogIsFocused = _context.sent;
            // dialog should be the focused element
            expect(dialogIsFocused).toBe(true); // dialog should be accessible

            _context.next = 18;
            return analyzeAccessibility(page);

          case 18:
            accessibilityReport = _context.sent;
            expect(accessibilityReport).toHaveNoAccessibilityIssues(); // close again

            _context.next = 22;
            return page.click(selectors.closeButton);

          case 22:
            _context.next = 24;
            return page.waitFor(selectors.closeButton, {
              hidden: true
            });

          case 24:
            _context.next = 26;
            return page.$eval(selectors.openModal, function (button) {
              return button === document.activeElement;
            });

          case 26:
            openIsFocused = _context.sent;
            expect(openIsFocused).toBe(true);

          case 28:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
});