"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.suite = void 0;

var React = _interopRequireWildcard(require("react"));

var _statefulPagination = _interopRequireDefault(require("./stateful-pagination.js"));

var _pagination = _interopRequireDefault(require("./pagination.js"));

var _index = require("../button/index.js");

var _examplesList = _interopRequireDefault(require("./examples-list.js"));

var _examples$STATEFUL_PA;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var suite = 'Pagination Test Suite';
exports.suite = suite;

var _default = (_examples$STATEFUL_PA = {}, _defineProperty(_examples$STATEFUL_PA, _examplesList.default.STATEFUL_PAGINATION, function Story1() {
  return React.createElement(_statefulPagination.default, {
    overrides: {
      NextButton: {
        props: {
          'data-test': 'next-button'
        }
      },
      PrevButton: {
        props: {
          'data-test': 'prev-button'
        }
      },
      DropdownButton: {
        props: {
          'data-test': 'dropdown-button'
        }
      }
    },
    numPages: 10
  });
}), _defineProperty(_examples$STATEFUL_PA, _examplesList.default.STATELESS_PAGINATION, function Story2() {
  return React.createElement(_pagination.default, {
    numPages: 18,
    currentPage: 4
  });
}), _defineProperty(_examples$STATEFUL_PA, _examplesList.default.PAGINATION_OVERRIDE, function Story2() {
  return React.createElement(_statefulPagination.default, {
    numPages: 10,
    labels: {
      prevButton: 'Back',
      nextButton: 'Forward',
      preposition: 'out of'
    },
    overrides: {
      NextButton: {
        props: {
          kind: _index.KIND.secondary
        }
      },
      PrevButton: {
        props: {
          kind: _index.KIND.secondary
        }
      },
      DropdownMenu: {
        style: {
          top: '100px'
        }
      }
    }
  });
}), _examples$STATEFUL_PA);

exports.default = _default;