"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    analyzeAccessibility = _require.analyzeAccessibility,
    getPuppeteerUrl = _require.getPuppeteerUrl;

var suite = 'Popover Test Suite';
var selectors = {
  tooltip: '[role="tooltip"]'
};
describe(suite, function () {
  it('passes basic a11y tests',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var accessibilityReport;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.SIMPLE_EXAMPLE
            }));

          case 2:
            _context.next = 4;
            return page.waitFor(selectors.tooltip);

          case 4:
            _context.next = 6;
            return analyzeAccessibility(page);

          case 6:
            accessibilityReport = _context.sent;
            expect(accessibilityReport).toHaveNoAccessibilityIssues();

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
  it('hover opens the popover',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.WITH_HOVER
            }));

          case 2:
            _context2.next = 4;
            return page.waitFor('button');

          case 4:
            _context2.next = 6;
            return page.hover('button');

          case 6:
            _context2.next = 8;
            return page.waitFor(selectors.tooltip);

          case 8:
            _context2.next = 10;
            return page.mouse.move(0, 0);

          case 10:
            _context2.next = 12;
            return page.waitFor(selectors.tooltip, {
              hidden: true
            });

          case 12:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  })));
  it('opened popover can be closed with ESC',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.WITH_CLICK
            }));

          case 2:
            _context3.next = 4;
            return page.waitFor('button');

          case 4:
            _context3.next = 6;
            return page.click('button');

          case 6:
            _context3.next = 8;
            return page.waitFor(selectors.tooltip);

          case 8:
            _context3.next = 10;
            return page.keyboard.press('Escape');

          case 10:
            _context3.next = 12;
            return page.waitFor(selectors.tooltip, {
              hidden: true
            });

          case 12:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));
});