"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Spinner styled components', function () {
  test('StyledSvg - basic render', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledSvg, null));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledSvg has correct default styles');
  });
  test('StyledSvg - custom size', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledSvg, {
      size: 56
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledSvg has correct height and width styles');
  });
  test('StyledSvg - custom color', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_index.StyledSvg, {
      color: "#00FF00"
    }));
    expect(component.instance().getStyles()).toMatchSnapshot('StyledSvg has correct fill value');
  });
});