"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _index = require("../index.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
describe('Table styled components', function () {
  var styledComponents = [[_index.StyledTable, 'StyledTable'], [_index.StyledContent, 'StyledContent'], [_index.StyledHead, 'StyledHead'], [_index.StyledHeadCell, 'StyledHeadCell'], [_index.StyledBody, 'StyledBody'], [_index.StyledRow, 'StyledRow'], [_index.StyledCell, 'StyledCell']];
  test.each(styledComponents)('default properties', function (Component, name) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has expected default styles"));
  });
  test.each(styledComponents)('$width property', function (Component, name) {
    var component = (0, _enzyme.shallow)(_react.default.createElement(Component, {
      $width: "1000px"
    }));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has expected styles when $width property defined"));
  });
});